/*
 * menulex.hh - Declares the MenuLex class which is used to parse the menu configuration file.
 * Copyright (C) 2000 Frank Hale
 * frankhale@lycos.com
 * http://sapphire.sourceforge.net/
 *
 * Updated: 5 Nov 2000
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#ifndef _MENULEX_HH_
#define _MENULEX_HH_

class MenuLex : public Scanner
{
private:
	char* name;
	char* exe;
	
	RootMenu *root;

	LinkedList<BaseMenu> *menulist;

	int submenus;

	BaseMenu *sub1;
	BaseMenu *sub2;
	BaseMenu *sub3;
	BaseMenu *sub4;
	
	bool error;

public:
	MenuLex(char *filename, RootMenu *menu);
	~MenuLex();
	
	void parse();

private:
	bool menu(bool validate);
	bool exec(BaseMenu *sub, bool validate);
	bool theme(BaseMenu *sub, bool validate);
	bool submenu(BaseMenu *sub, bool validate);
	bool separator(BaseMenu *sub, bool validate);
	bool exit(BaseMenu* sub, bool validate);
	bool restart(BaseMenu* sub, bool validate);
	bool reconfigure(BaseMenu* sub, bool validate);
	
	BaseMenu* getMenu(int index);	
	BaseMenu* getLastMenu();
	
	bool statement(BaseMenu *sub, bool validate);
};

#endif
