/*
 * windowmenu.hh - Defines the way the window menu will behave
 * Copyright (C) 2000 Frank Hale, Felipe Bergo
 * frankhale@lycos.com
 * http://sapphire.sourceforge.net/
 *
 * Updated: 5 Nov 2000
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#ifndef _WINDOWMENU_HH
#define _WINDOWMENU_HH

class WindowMenuItem : public BaseMenuItem {
public:
	WindowState wstate;
	int         desktop;
};

class WindowMenu : public FancyMenu
{
public:
	WindowMenu();
	~WindowMenu();

	void update_states();

	void insert(char *name, Client *c, WindowState _state);
	void addWindow(char *name, Client *c, WindowState _state);
	void removeWindow(Client *c);

	void handle_button1_press(BaseMenuItem* curr);
	void handle_button1_release(BaseMenuItem* curr);

	// brings window to current desktop
	void handle_button2_press(BaseMenuItem* curr);
	void handle_button3_press(BaseMenuItem* curr);

	void setAllMenuTitlesVisible(BaseMenu *sub, bool s);
};

#endif 
